#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

typedef long long ll;
ll n,p[1000001],q;

int main() {

    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    cin>>n>>q;
    p[0]=0;
    for(int i=1;i<=n;i++) {
        ll a;
        cin>>a;
        p[i]=p[i-1]+a;
    }

    while(q--) {
        int t;
        cin>>t;
        if(t==1) {
            int j;
            cin>>j;
            int a=p[j]-p[j-1];
            for(int i=j;i<=n;i++) p[j]-=2*a;
        }
        else {
            int l,r;
            cin>>l>>r;
            int k=0;
            for(int i=l;i<=r;i++) for(int j=r;j>=i;j--) {
                bool fl=0;
                for(int m=i;m<=j;m++) if(min(p[m]-p[i-1], p[j]-p[m-1])<0) {fl=1; break;}
                if(!fl) k=max(k, j-i+1);
            }
            cout<<k<<endl;
        }

    }

    return 0;
}

